/**
 * CRFalign: A CRF-based sentence aligner for parallel corpora.
 *
 * Copyright (C) 2012 Eva Mujdricza-Maydt Copyright (C) 2012 Huiqin Körkel-Qu
 *
 * This program is free software: you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation, either version 3 of the License, or (at your option) any later
 * version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details.
 *
 * You should have received a copy of the GNU General Public License along with
 * this program. If not, see <http://www.gnu.org/licenses/>.
 *
 * Developers: - Eva Mujdricza-Maydt (mujdricz@cl.uni-heidelberg.de) - Huiqin
 * Körkel-Qu (huiqin@cl.uni-heidelberg.de)
 */
package diceMatrix;

/**
 * because the crf tool(wapiti) can only handle discrete feature, the double
 * value is changed to be a string (keep only some bits of the double value)
 *
 * @author Huiqin Körkel-Qu
 */
public class doubleToString {

	public static String toBinaryFeature(double inValue, int bitNum) {
		//inValue is the value to be round, bitNum is how many bit will be keep after .

		int expand = 1;
		for (int i = 0; i < bitNum; i++) {
			expand *= 10;
		}
		double expandValue = inValue * expand;
		//from http://topic.csdn.net/t/20041201/09/3604201.html
		java.text.NumberFormat formate = java.text.NumberFormat.getNumberInstance();
		formate.setMaximumFractionDigits(0);
		String output = formate.format(expandValue);

		return output.split("\\.")[0];
	}
}
