/**
 * CRFalign: A CRF-based sentence aligner for parallel corpora.
 *
 * Copyright (C) 2012 Eva Mujdricza-Maydt Copyright (C) 2012 Huiqin Körkel-Qu
 *
 * This program is free software: you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation, either version 3 of the License, or (at your option) any later
 * version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details.
 *
 * You should have received a copy of the GNU General Public License along with
 * this program. If not, see <http://www.gnu.org/licenses/>.
 *
 * Developers: - Eva Mujdricza-Maydt (mujdricz@cl.uni-heidelberg.de) - Huiqin
 * Körkel-Qu (huiqin@cl.uni-heidelberg.de)
 */
package diceMatrix;

import java.util.ArrayList;

/**
 * get one sentence according to the sentence Id, or get a group of sentence
 * according to the array of sentence Ids
 *
 * @author Huiqin Körkel-Qu
 */
public class getSent {

	public static int[] get(ArrayList<int[]> sentArray, int[] sentGroup) {

		int wordsNum = 0;
		for (int i = 0; i < sentGroup.length; i++) {
//			// the case the sentence id is larger than the sentence num(by error data)!
//			if(sentArray.size()>=sentGroup[i])
//				return null;

			if (sentArray.size() <= sentGroup[i]) {
				return null;
			}
			if (null != sentArray.get(sentGroup[i])) {
				wordsNum += sentArray.get(sentGroup[i]).length;
			}
		}
		// all the sentences only contains stop words
		if (wordsNum == 0) {
			return null;
		}

		int sentWords[] = new int[wordsNum];
		int wordNum = 0;
		for (int j = 0; j < sentGroup.length; j++) {

			if (null == sentArray.get(sentGroup[j])) {
				continue;
			}
			int[] sentWordList = sentArray.get(sentGroup[j]);
			if (null == sentWordList) {
				return null;
			}

			/*
			 * System.out.println("now the sent is:"); for(int
			 * test=0;test<sentWordList.length;test++) {
			 * System.out.print(sentWordList[test]+" "); }
			System.out.println();
			 */

			for (int currentNum = 0; currentNum < sentWordList.length; currentNum++) {
				sentWords[wordNum + currentNum] = sentWordList[currentNum];
			}
			wordNum += sentWordList.length;
		}

//		if(sentWords.length ==0)
//		{
//			System.out.println("unsucessful in geting sentences!");
//		}
		return sentWords;
	}

	// the sentNum is 1 less than shows in file, eg, in file the sentence num start with 1
	//but here, it start from 0
	// so if to get the a sentence from diceFile or alignment file(where sentence num start from 1),
	// the sentNum should be the num-1;
	public static int[] getSingleSent(ArrayList<int[]> sentArray, int sentNum) {
		try {
			if (0 <= sentNum && sentNum < sentArray.size()) {
				return sentArray.get(sentNum);
			}
			return null;
		} catch (Exception o) {
			return null;
		}
	}
}