/**
 * CRFalign: A CRF-based sentence aligner for parallel corpora.
 *
 * Copyright (C) 2012 Eva Mujdricza-Maydt Copyright (C) 2012 Huiqin Körkel-Qu
 *
 * This program is free software: you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation, either version 3 of the License, or (at your option) any later
 * version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details.
 *
 * You should have received a copy of the GNU General Public License along with
 * this program. If not, see <http://www.gnu.org/licenses/>.
 *
 * Developers: - Eva Mujdricza-Maydt (mujdricz@cl.uni-heidelberg.de) - Huiqin
 * Körkel-Qu (huiqin@cl.uni-heidelberg.de)
 */
package general.orderAlign;

import java.util.ArrayList;

/**
 * 
 * @author Huiqin Körkel-Qu
 */
public class conflict1to2 {

	public static void resolve(ArrayList<String> allAlign) {
		String[] continue4Align = new String[]{"", "", "", ""};

		for (int i = 0; i < allAlign.size() + 1; i++) {
			if (continue4Align[3].equals("empty") && i != allAlign.size()) {
				continue4Align[3] = allAlign.get(i);
			} else {
				continue4Align[0] = continue4Align[1];
				continue4Align[1] = continue4Align[2];
				continue4Align[2] = continue4Align[3];

				if (i < allAlign.size()) {
					continue4Align[3] = allAlign.get(i);
				} // for the confliction that happens at the last 2 lines.
				else {
					continue4Align[3] = "-1;-1";
				}
			}

			String conflictLineFirst;
			String conflictLineSecond;
			String conflictLineBefore;
			String conflictLineAfter;
			@SuppressWarnings("unused")
			int targetBefore;
			int targetAfter;

			try {
				conflictLineBefore = continue4Align[0].split(";")[1];
				targetBefore = Integer.parseInt(conflictLineBefore.split(" ")[1].toString());
			} catch (Exception o) {
				conflictLineBefore = "-1";
				targetBefore = -1;
			}
			//the conflict lines must be there!
			try {
				conflictLineFirst = continue4Align[1].split(";")[1];
				conflictLineSecond = continue4Align[2].split(";")[1];
			} catch (Exception o) {

				continue;
			}
			if (conflictLineFirst.equals("") || conflictLineSecond.equals("")) {
				continue;
			}
			try {
				conflictLineAfter = continue4Align[3].split(";")[1];
				targetAfter = Integer.parseInt(conflictLineAfter.split(" ")[0].toString());
			} catch (Exception o) {
				conflictLineAfter = "-1";
				targetAfter = -1;
			}

			if (conflictLineFirst.split(" ")[0].equals(conflictLineSecond.split(" ")[0])) {
				if (conflictLineFirst.split(" ").length == 2
					&& conflictLineSecond.split(" ").length == 1) //350;346
				//351;347 348
				//352;347
				//353;349
				{
					int targetConflictFirst = Integer.parseInt(conflictLineFirst.split(" ")[0]);
//					int sourceConflictSecond=Integer.parseInt(conflictLineBefore.split(" ")[1].toString());	
					if (targetConflictFirst + 2 == targetAfter) {
						//369;386
						//370 371;387
						//370;387
						//372;388
						//target are the same
						if (continue4Align[1].split(";")[0].equals(continue4Align[2].split(";")[0])) {
							allAlign.remove(i - 1);
							continue4Align[2] = continue4Align[3];
							continue4Align[3] = "empty";
						} else //369;386
						//370 371;386
						//370;387
						//372;388
						{
							// the conflict not only happens in one side, confliction cann't be resolved
						}
					}
				} else if (conflictLineFirst.split(" ").length == 1
					&& conflictLineSecond.split(" ").length == 2) //369;386
				//370;387
				//370 371;387
				//372;388
				{
					int targetConflictFirst = Integer.parseInt(conflictLineFirst.split(" ")[0].toString());
//				int sourceConflictSecond=Integer.parseInt(conflictLineBefore.split(" ")[1].toString());	
					if (targetConflictFirst + 2 == targetAfter) {
						try {
							if (continue4Align[1].split(";")[0].equals(continue4Align[2].split(";")[0])) {
								allAlign.remove(i - 3);
								continue4Align[1] = continue4Align[2];
								continue4Align[2] = continue4Align[3];
								continue4Align[3] = "empty";
							} else {
								// the conflict not only happens in one side, confliction cann't be resolved
							}
						} catch (Exception o) {
						}
					}
				} else if (conflictLineFirst.split(" ").length == 1
					&& conflictLineSecond.split(" ").length == 1) {
					//369;386
					//370;387
					//370;409
					//372;388

					try {
						int lastSId = Integer.parseInt(continue4Align[0].split(";")[0].split(" ")[continue4Align[0].split(";")[0].split(" ").length - 1]);

						int nextSId = Integer.parseInt(continue4Align[3].split(";")[0].split(" ")[0]);
						int conflictSIdFirst = Integer.parseInt(continue4Align[1].split(";")[0].split(" ")[continue4Align[1].split(";")[0].split(" ").length - 1]);
						int conflictSIdSecond = Integer.parseInt(continue4Align[2].split(";")[0].split(" ")[continue4Align[2].split(";")[0].split(" ").length - 1]);

						//369;386
						//370;387
						//370;409
						//372;388
						if (conflictSIdFirst == lastSId + 1 || conflictSIdFirst == nextSId - 1) {
							allAlign.remove(i - 1);
							continue4Align[2] = continue4Align[3];
							continue4Align[3] = "empty";

						} //369;386
						//370;343
						//370;387
						//372;388
						else if (conflictSIdSecond == lastSId + 1 || conflictSIdSecond == nextSId - 1) {
							allAlign.remove(i - 2);
							continue4Align[1] = continue4Align[2];
							continue4Align[2] = continue4Align[3];
							continue4Align[3] = "empty";
						} else {
							// more than 1 conflict, cann't be resolved.
						}
					} catch (Exception o) {
					}
				}

			} else if (conflictLineFirst.split(" ").length == 2
				&& conflictLineFirst.split(" ")[1].equals(conflictLineSecond.split(" ")[0])) // 323;354
			//324:355 356
			//325:356
			//326:357
			// the case 
			// 323;354
			//324:355
			//325:354 355
			//326:357
			//will not happen. maybe with very bad alignments?
			{
				try {
					String TIdLineBefore = continue4Align[0].split(";")[1];
					int TIdNumBefore = TIdLineBefore.split(" ").length;
					int TIdBefore = Integer.parseInt(TIdLineBefore.split(" ")[TIdNumBefore - 1]);
					@SuppressWarnings("unused")
					int TIdAfter = Integer.parseInt(continue4Align[3].split(";")[1].split(" ")[0]);
					int conflictTId = Integer.parseInt(conflictLineFirst.split(" ")[1]);

					if (conflictTId == TIdBefore + 2) {
						allAlign.remove(i - 1);
						continue4Align[2] = continue4Align[3];
						continue4Align[3] = "empty";
					}
				} catch (Exception o) {
				}
			}
		}
	}
}