/**
 * CRFalign: A CRF-based sentence aligner for parallel corpora.
 *
 * Copyright (C) 2012 Eva Mujdricza-Maydt Copyright (C) 2012 Huiqin Körkel-Qu
 *
 * This program is free software: you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation, either version 3 of the License, or (at your option) any later
 * version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details.
 *
 * You should have received a copy of the GNU General Public License along with
 * this program. If not, see <http://www.gnu.org/licenses/>.
 *
 * Developers: - Eva Mujdricza-Maydt (mujdricz@cl.uni-heidelberg.de) - Huiqin
 * Körkel-Qu (huiqin@cl.uni-heidelberg.de)
 */
package general.orderAlign;

import java.io.IOException;
import java.util.ArrayList;
import java.util.Collections;

/**
 * from a alignment files get a sorted alignment array
 *
 * @author Huiqin Körkel-Qu
 *
 * @param <T>
 */
public class orderedAlign<T> {

	String fileName;

	public static ArrayList<String> order(ArrayList<String> allAlign) throws IOException {

		//short according to sIds, if sIds are the same, sort acording to tIds.
		Mycomparator alignorder = new Mycomparator();
		Collections.sort(allAlign, alignorder);
		ArrayList<String> sourceNull = new ArrayList<String>();
		ArrayList<Integer> removeList = new ArrayList<Integer>();
		ArrayList<String> copy = new ArrayList<String>();

		for (int i = 0; i < allAlign.size(); i++) {
			copy.add(allAlign.get(i));
		}

		for (int i = 0; i < allAlign.size(); i++) {

			if (allAlign.get(i).split(";")[0].equals("") || allAlign.get(i).split(";")[0].length() == 0) {
				sourceNull.add(allAlign.get(i));
				removeList.add(i);
			}
		}
		allAlign.clear();

		for (int i = 0; i < copy.size(); i++) {
			if (!removeList.contains(i)) {
				allAlign.add(copy.get(i));
			}
		}

		for (String sourcenull : sourceNull) {
			int targetSourceNullId = Integer.parseInt(sourcenull.split(";")[1].split("\\s+")[0]);
			int targetId = 0;
			for (int i = 0; i < allAlign.size(); i++) {
				if (allAlign.get(i).split(";").length == 2) {
					targetId = Integer.parseInt(allAlign.get(i).split(";")[1].split("\\s+")[0]);
					if (targetId > targetSourceNullId) {
						allAlign.add(i, sourcenull);
						break;
					}
				}
			}
		}

		return allAlign;

	}
//	public void writeAlign(ArrayList<String> allAlign,String fileName) throws IOException
//	{
//		File orderedFile=new File(fileName+".addEmpty");
//		BufferedWriter bw=new BufferedWriter(new FileWriter(orderedFile));
//		for(int i=0;i<allAlign.size();i++)
//		{
//			bw.write(allAlign.get(i));
//			bw.write("\n");
//			
//		}
//		bw.flush();
//		bw.close();
//	
//		
//	}
//	
//	public void order(ArrayList<String> allAlign)
//	{
//
//		Mycomparator alignorder=new Mycomparator();
//	    Collections.sort(allAlign, alignorder);
//	    return;
//	}
//	
//	public static void main(String[] args) throws IOException
//	 {
//		 orderedAlign<Object> align=new orderedAlign<Object>();
//
//			final String FILEPATH="/mnt/proj/ma-research/ss-2011/tofeature/wapiti/result/alignment/";
////			final String FILEPATH="/home/huiqin/data/qhqcl/forchungcl/opusdata/result/";
//			File dir=new File(FILEPATH);
//		    File file[] = dir.listFiles();
//	        for(int i=0;i<file.length;i++)
//	        {
//	        	if(file[i].isFile()&&file[i].getName().contains("largestSeq")
//	        			&&!file[i].getName().contains("order")&&!file[i].getName().contains("noconflic"))
//	        	{
//	        		System.out.println("file name is:"+file[i].getName());
//	        		ArrayList<String>alignment=
//	        		align.order(file[i].getAbsolutePath());
////        		    new conflict2to1().resolve(alignment);
////	        		new conflict1to2().resolve(alignment);
//	        		int[] range=new int[2];
//	        	
//	        		if(file[i].getName().contains("4072084"))
//	        		{
//	        			range[0]=677;
//	        			range[1]=690;
//	        		}
//	        		else if(file[i].getName().contains("4088225"))
//	        		{
//	        			range[0]=677;
//	        			range[1]=690;
//	        		}
//	        		else if(file[i].getName().contains("4089509"))
//	        		{
//	        			range[0]=642;
//	        			range[1]=629;
//	        		}
//	        		
//	        		else if(file[i].getName().contains("4098146"))
//	        		{
//	        			range[0]=646;
//	        			range[1]=660;
//	        		}
//	        		
//	        		else if(file[i].getName().contains("4124568"))
//	        		{
//	        			range[0]=621;
//	        			range[1]=629;
//	        		}
//	        		
//	        		else if(file[i].getName().contains("4135819"))
//	        		{
//	        			range[0]=862;
//	        			range[1]=857;
//	        		}
//	        		else{
//	        			range[0]=0;
//	        			range[1]=0;
//	        		}
//	        		
//	        		 addEmpty.add(alignment,  range[0], range[1], 1);		
//	        		align.order(alignment);
//	        		new sortWithTarget().sort(alignment);
//	        		align.writeAlign(alignment, file[i].getAbsolutePath());
//	        }
//	        }
//		 
//	 }
}
